/**
 * This code is written to demonstrate how an HTTP server works.
 * As such it is not bullet-proof.
 * This is free software. Users are required to acknowledge this author.
 */
package main;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * @author dhou
 *
 */
public class Server0 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		ServerSocket server = null;
		try {
			server = new ServerSocket(8808);
		}
		catch (IOException ioe){
			System.err.println("Cannot open server socket. Program quits");
			ioe.printStackTrace();
			System.exit(-1);
		}
		if (server==null){
			System.err.println("Cannot open server socket. Program quits");
			System.exit(-1);			
		}
		
		while (true){
		try {
			Socket socket = server.accept();
			InputStream is = socket.getInputStream();
			InputStreamReader ir = new InputStreamReader(is);
//			BufferedReader bufReader = new BufferedReader(ir);
			int i;
			int line=0;
			while (line!=6){
				i= ir.read();
				System.out.print((char)i);
				if (i=='\n') ++line;
			}
			
			OutputStream os = socket.getOutputStream();
			Writer ow = new OutputStreamWriter(os);
			ow.write("<!DOCTYPE html PUBLIC \"-//IETF//DTD HTML 2.0//EN\">");
			ow.write("<html>");
			ow.write(" <head>");
			ow.write("  <title>");
			ow.write("   Hello World Demonstration Document");
			ow.write("</title>");
			ow.write("</head>");
			ow.write("<body>");
			ow.write("<h1>");
			ow.write("Hello, World!");
			ow.write("</h1>");
			ow.write(" </body>");
			ow.write("</html>");
			ow.close();
		}
		catch (IOException ioe){
		System.err.println("Cannot accept connection to the server socket. Program quits");
		ioe.printStackTrace();
		break;
		}
		}

		try {
			server.close();
		}
		catch (IOException ioe){
			System.err.println("Cannot close server socket. Program quits");
			ioe.printStackTrace();
			System.exit(-1);
		}

	}

}
