/**
 * This code is written to demonstrate how an HTTP server works.
 * As such it is not bullet-proof.
 * This is free software. Users are required to acknowledge this author.
 */
package main;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * @author dhou
 *
 */
public class Server1 {

	static ServerSocket server = null;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			server = new ServerSocket(8808);
		}
		catch (IOException ioe){
			System.err.println("Cannot open server socket. Program quits");
			ioe.printStackTrace();
			System.exit(-1);
		}
		if (server==null){
			System.err.println("Cannot open server socket. Program quits");
			System.exit(-1);			
		}

		try {
		while (true){
		   serve();	
		}
		}
		catch (Exception e){
			System.err.println("Exception raised while processing http requests. Program quits");
			e.printStackTrace();				
			try {
			server.close();
			}
			catch (IOException ioe){
				System.err.println("Cannot close server socket. Program quits");
				ioe.printStackTrace();				
			}
		}

	}
	
	static void serve(){
		
		try {
			Socket socket = server.accept();
			InputStream is = socket.getInputStream();
			InputStreamReader ir = new InputStreamReader(is);
			StringBuffer method = new StringBuffer();
			int i;
			do {
				i= ir.read();
			} while (Character.isWhitespace((char)i));
			while (Character.isLetter((char)i)){
				method.append((char)i);
				i= ir.read();
			}
			
			while (Character.isWhitespace((char)i)) {
				 i= ir.read();
			 }

			
			i= ir.read(); // the leading '/' has been skipped by now
			StringBuffer uri= new StringBuffer("./web/");
			if (Character.isLetter((char)i)){
				while (Character.isLetter((char)i)||'/'==i||'.'==i){
					uri.append((char)i);
					i= ir.read();
				}
			}
			else {uri.append("index.html");}
			
			System.out.println("|"+method+"|");
			System.out.println("|"+uri+"|");
			
			File file = new File(uri.toString());
			InputStream in = new FileInputStream(file);
			OutputStream os = socket.getOutputStream();
			while ((i=in.read())!=-1){
				os.write(i);
			}
			in.close();
			os.close();
		}
		catch (IOException ioe){
		System.err.println("Cannot accept connection to the server socket. Program ignores");
		ioe.printStackTrace();
		}
	}

}
